Merge branch 'mo/bin-wrappers'
[git/git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 # if --tee was passed, write the output not only to the terminal, but
7 # additionally to the file test-results/$BASENAME.out, too.
8 case "$GIT_TEST_TEE_STARTED, $* " in
9 done,*)
10 # do not redirect again
11 ;;
12 *' --tee '*|*' --va'*)
13 mkdir -p test-results
14 BASE=test-results/$(basename "$0" .sh)
15 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
16 echo $? > $BASE.exit) | tee $BASE.out
17 test "$(cat $BASE.exit)" = 0
18 exit
19 ;;
20 esac
21
22 # Keep the original TERM for say_color
23 ORIGINAL_TERM=$TERM
24
25 # For repeatability, reset the environment to known value.
26 LANG=C
27 LC_ALL=C
28 PAGER=cat
29 TZ=UTC
30 TERM=dumb
31 export LANG LC_ALL PAGER TERM TZ
32 EDITOR=:
33 unset VISUAL
34 unset GIT_EDITOR
35 unset AUTHOR_DATE
36 unset AUTHOR_EMAIL
37 unset AUTHOR_NAME
38 unset COMMIT_AUTHOR_EMAIL
39 unset COMMIT_AUTHOR_NAME
40 unset EMAIL
41 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
42 unset GIT_AUTHOR_DATE
43 GIT_AUTHOR_EMAIL=author@example.com
44 GIT_AUTHOR_NAME='A U Thor'
45 unset GIT_COMMITTER_DATE
46 GIT_COMMITTER_EMAIL=committer@example.com
47 GIT_COMMITTER_NAME='C O Mitter'
48 unset GIT_DIFF_OPTS
49 unset GIT_DIR
50 unset GIT_WORK_TREE
51 unset GIT_EXTERNAL_DIFF
52 unset GIT_INDEX_FILE
53 unset GIT_OBJECT_DIRECTORY
54 unset GIT_CEILING_DIRECTORIES
55 unset SHA1_FILE_DIRECTORIES
56 unset SHA1_FILE_DIRECTORY
57 GIT_MERGE_VERBOSITY=5
58 export GIT_MERGE_VERBOSITY
59 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
60 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
61 export EDITOR
62 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
63
64 # Protect ourselves from common misconfiguration to export
65 # CDPATH into the environment
66 unset CDPATH
67
68 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
69 1|2|true)
70 echo "* warning: Some tests will not work if GIT_TRACE" \
71 "is set as to trace on STDERR ! *"
72 echo "* warning: Please set GIT_TRACE to something" \
73 "other than 1, 2 or true ! *"
74 ;;
75 esac
76
77 # Each test should start with something like this, after copyright notices:
78 #
79 # test_description='Description of this test...
80 # This test checks if command xyzzy does the right thing...
81 # '
82 # . ./test-lib.sh
83 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
84 TERM=$ORIGINAL_TERM &&
85 export TERM &&
86 [ -t 1 ] &&
87 tput bold >/dev/null 2>&1 &&
88 tput setaf 1 >/dev/null 2>&1 &&
89 tput sgr0 >/dev/null 2>&1
90 ) &&
91 color=t
92
93 while test "$#" -ne 0
94 do
95 case "$1" in
96 -d|--d|--de|--deb|--debu|--debug)
97 debug=t; shift ;;
98 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
99 immediate=t; shift ;;
100 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
101 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
102 -h|--h|--he|--hel|--help)
103 help=t; shift ;;
104 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
105 verbose=t; shift ;;
106 -q|--q|--qu|--qui|--quie|--quiet)
107 quiet=t; shift ;;
108 --with-dashes)
109 with_dashes=t; shift ;;
110 --no-color)
111 color=; shift ;;
112 --no-python)
113 # noop now...
114 shift ;;
115 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
116 valgrind=t; verbose=t; shift ;;
117 --tee)
118 shift ;; # was handled already
119 --root=*)
120 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
121 shift ;;
122 *)
123 echo "error: unknown test option '$1'" >&2; exit 1 ;;
124 esac
125 done
126
127 if test -n "$color"; then
128 say_color () {
129 (
130 TERM=$ORIGINAL_TERM
131 export TERM
132 case "$1" in
133 error) tput bold; tput setaf 1;; # bold red
134 skip) tput bold; tput setaf 2;; # bold green
135 pass) tput setaf 2;; # green
136 info) tput setaf 3;; # brown
137 *) test -n "$quiet" && return;;
138 esac
139 shift
140 printf "* %s" "$*"
141 tput sgr0
142 echo
143 )
144 }
145 else
146 say_color() {
147 test -z "$1" && test -n "$quiet" && return
148 shift
149 echo "* $*"
150 }
151 fi
152
153 error () {
154 say_color error "error: $*"
155 GIT_EXIT_OK=t
156 exit 1
157 }
158
159 say () {
160 say_color info "$*"
161 }
162
163 test "${test_description}" != "" ||
164 error "Test script did not set test_description."
165
166 if test "$help" = "t"
167 then
168 echo "$test_description"
169 exit 0
170 fi
171
172 exec 5>&1
173 if test "$verbose" = "t"
174 then
175 exec 4>&2 3>&1
176 else
177 exec 4>/dev/null 3>/dev/null
178 fi
179
180 test_failure=0
181 test_count=0
182 test_fixed=0
183 test_broken=0
184 test_success=0
185
186 die () {
187 code=$?
188 if test -n "$GIT_EXIT_OK"
189 then
190 exit $code
191 else
192 echo >&5 "FATAL: Unexpected exit with code $code"
193 exit 1
194 fi
195 }
196
197 GIT_EXIT_OK=
198 trap 'die' EXIT
199
200 # The semantics of the editor variables are that of invoking
201 # sh -c "$EDITOR \"$@\"" files ...
202 #
203 # If our trash directory contains shell metacharacters, they will be
204 # interpreted if we just set $EDITOR directly, so do a little dance with
205 # environment variables to work around this.
206 #
207 # In particular, quoting isn't enough, as the path may contain the same quote
208 # that we're using.
209 test_set_editor () {
210 FAKE_EDITOR="$1"
211 export FAKE_EDITOR
212 EDITOR='"$FAKE_EDITOR"'
213 export EDITOR
214 }
215
216 test_decode_color () {
217 sed -e 's/.\[1m/<WHITE>/g' \
218 -e 's/.\[31m/<RED>/g' \
219 -e 's/.\[32m/<GREEN>/g' \
220 -e 's/.\[33m/<YELLOW>/g' \
221 -e 's/.\[34m/<BLUE>/g' \
222 -e 's/.\[35m/<MAGENTA>/g' \
223 -e 's/.\[36m/<CYAN>/g' \
224 -e 's/.\[m/<RESET>/g'
225 }
226
227 test_tick () {
228 if test -z "${test_tick+set}"
229 then
230 test_tick=1112911993
231 else
232 test_tick=$(($test_tick + 60))
233 fi
234 GIT_COMMITTER_DATE="$test_tick -0700"
235 GIT_AUTHOR_DATE="$test_tick -0700"
236 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
237 }
238
239 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
240 #
241 # This will commit a file with the given contents and the given commit
242 # message. It will also add a tag with <message> as name.
243 #
244 # Both <file> and <contents> default to <message>.
245
246 test_commit () {
247 file=${2:-"$1.t"}
248 echo "${3-$1}" > "$file" &&
249 git add "$file" &&
250 test_tick &&
251 git commit -m "$1" &&
252 git tag "$1"
253 }
254
255 # Call test_merge with the arguments "<message> <commit>", where <commit>
256 # can be a tag pointing to the commit-to-merge.
257
258 test_merge () {
259 test_tick &&
260 git merge -m "$1" "$2" &&
261 git tag "$1"
262 }
263
264 # This function helps systems where core.filemode=false is set.
265 # Use it instead of plain 'chmod +x' to set or unset the executable bit
266 # of a file in the working directory and add it to the index.
267
268 test_chmod () {
269 chmod "$@" &&
270 git update-index --add "--chmod=$@"
271 }
272
273 # Use test_set_prereq to tell that a particular prerequisite is available.
274 # The prerequisite can later be checked for in two ways:
275 #
276 # - Explicitly using test_have_prereq.
277 #
278 # - Implicitly by specifying the prerequisite tag in the calls to
279 # test_expect_{success,failure,code}.
280 #
281 # The single parameter is the prerequisite tag (a simple word, in all
282 # capital letters by convention).
283
284 test_set_prereq () {
285 satisfied="$satisfied$1 "
286 }
287 satisfied=" "
288
289 test_have_prereq () {
290 case $satisfied in
291 *" $1 "*)
292 : yes, have it ;;
293 *)
294 ! : nope ;;
295 esac
296 }
297
298 # You are not expected to call test_ok_ and test_failure_ directly, use
299 # the text_expect_* functions instead.
300
301 test_ok_ () {
302 test_success=$(($test_success + 1))
303 say_color "" " ok $test_count: $@"
304 }
305
306 test_failure_ () {
307 test_failure=$(($test_failure + 1))
308 say_color error "FAIL $test_count: $1"
309 shift
310 echo "$@" | sed -e 's/^/ /'
311 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
312 }
313
314 test_known_broken_ok_ () {
315 test_fixed=$(($test_fixed+1))
316 say_color "" " FIXED $test_count: $@"
317 }
318
319 test_known_broken_failure_ () {
320 test_broken=$(($test_broken+1))
321 say_color skip " still broken $test_count: $@"
322 }
323
324 test_debug () {
325 test "$debug" = "" || eval "$1"
326 }
327
328 test_run_ () {
329 eval >&3 2>&4 "$1"
330 eval_ret="$?"
331 return 0
332 }
333
334 test_skip () {
335 test_count=$(($test_count+1))
336 to_skip=
337 for skp in $GIT_SKIP_TESTS
338 do
339 case $this_test.$test_count in
340 $skp)
341 to_skip=t
342 esac
343 done
344 if test -z "$to_skip" && test -n "$prereq" &&
345 ! test_have_prereq "$prereq"
346 then
347 to_skip=t
348 fi
349 case "$to_skip" in
350 t)
351 say_color skip >&3 "skipping test: $@"
352 say_color skip "skip $test_count: $1"
353 : true
354 ;;
355 *)
356 false
357 ;;
358 esac
359 }
360
361 test_expect_failure () {
362 test "$#" = 3 && { prereq=$1; shift; } || prereq=
363 test "$#" = 2 ||
364 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
365 if ! test_skip "$@"
366 then
367 say >&3 "checking known breakage: $2"
368 test_run_ "$2"
369 if [ "$?" = 0 -a "$eval_ret" = 0 ]
370 then
371 test_known_broken_ok_ "$1"
372 else
373 test_known_broken_failure_ "$1"
374 fi
375 fi
376 echo >&3 ""
377 }
378
379 test_expect_success () {
380 test "$#" = 3 && { prereq=$1; shift; } || prereq=
381 test "$#" = 2 ||
382 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
383 if ! test_skip "$@"
384 then
385 say >&3 "expecting success: $2"
386 test_run_ "$2"
387 if [ "$?" = 0 -a "$eval_ret" = 0 ]
388 then
389 test_ok_ "$1"
390 else
391 test_failure_ "$@"
392 fi
393 fi
394 echo >&3 ""
395 }
396
397 test_expect_code () {
398 test "$#" = 4 && { prereq=$1; shift; } || prereq=
399 test "$#" = 3 ||
400 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
401 if ! test_skip "$@"
402 then
403 say >&3 "expecting exit code $1: $3"
404 test_run_ "$3"
405 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
406 then
407 test_ok_ "$2"
408 else
409 test_failure_ "$@"
410 fi
411 fi
412 echo >&3 ""
413 }
414
415 # test_external runs external test scripts that provide continuous
416 # test output about their progress, and succeeds/fails on
417 # zero/non-zero exit code. It outputs the test output on stdout even
418 # in non-verbose mode, and announces the external script with "* run
419 # <n>: ..." before running it. When providing relative paths, keep in
420 # mind that all scripts run in "trash directory".
421 # Usage: test_external description command arguments...
422 # Example: test_external 'Perl API' perl ../path/to/test.pl
423 test_external () {
424 test "$#" = 4 && { prereq=$1; shift; } || prereq=
425 test "$#" = 3 ||
426 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
427 descr="$1"
428 shift
429 if ! test_skip "$descr" "$@"
430 then
431 # Announce the script to reduce confusion about the
432 # test output that follows.
433 say_color "" " run $test_count: $descr ($*)"
434 # Run command; redirect its stderr to &4 as in
435 # test_run_, but keep its stdout on our stdout even in
436 # non-verbose mode.
437 "$@" 2>&4
438 if [ "$?" = 0 ]
439 then
440 test_ok_ "$descr"
441 else
442 test_failure_ "$descr" "$@"
443 fi
444 fi
445 }
446
447 # Like test_external, but in addition tests that the command generated
448 # no output on stderr.
449 test_external_without_stderr () {
450 # The temporary file has no (and must have no) security
451 # implications.
452 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
453 stderr="$tmp/git-external-stderr.$$.tmp"
454 test_external "$@" 4> "$stderr"
455 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
456 descr="no stderr: $1"
457 shift
458 say >&3 "expecting no stderr from previous command"
459 if [ ! -s "$stderr" ]; then
460 rm "$stderr"
461 test_ok_ "$descr"
462 else
463 if [ "$verbose" = t ]; then
464 output=`echo; echo Stderr is:; cat "$stderr"`
465 else
466 output=
467 fi
468 # rm first in case test_failure exits.
469 rm "$stderr"
470 test_failure_ "$descr" "$@" "$output"
471 fi
472 }
473
474 # This is not among top-level (test_expect_success | test_expect_failure)
475 # but is a prefix that can be used in the test script, like:
476 #
477 # test_expect_success 'complain and die' '
478 # do something &&
479 # do something else &&
480 # test_must_fail git checkout ../outerspace
481 # '
482 #
483 # Writing this as "! git checkout ../outerspace" is wrong, because
484 # the failure could be due to a segv. We want a controlled failure.
485
486 test_must_fail () {
487 "$@"
488 test $? -gt 0 -a $? -le 129 -o $? -gt 192
489 }
490
491 # test_cmp is a helper function to compare actual and expected output.
492 # You can use it like:
493 #
494 # test_expect_success 'foo works' '
495 # echo expected >expected &&
496 # foo >actual &&
497 # test_cmp expected actual
498 # '
499 #
500 # This could be written as either "cmp" or "diff -u", but:
501 # - cmp's output is not nearly as easy to read as diff -u
502 # - not all diff versions understand "-u"
503
504 test_cmp() {
505 $GIT_TEST_CMP "$@"
506 }
507
508 # Most tests can use the created repository, but some may need to create more.
509 # Usage: test_create_repo <directory>
510 test_create_repo () {
511 test "$#" = 1 ||
512 error "bug in the test script: not 1 parameter to test-create-repo"
513 owd=`pwd`
514 repo="$1"
515 mkdir -p "$repo"
516 cd "$repo" || error "Cannot setup test environment"
517 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
518 error "cannot run git init -- have you built things yet?"
519 mv .git/hooks .git/hooks-disabled
520 cd "$owd"
521 }
522
523 test_done () {
524 GIT_EXIT_OK=t
525 test_results_dir="$TEST_DIRECTORY/test-results"
526 mkdir -p "$test_results_dir"
527 test_results_path="$test_results_dir/${0%.sh}-$$"
528
529 echo "total $test_count" >> $test_results_path
530 echo "success $test_success" >> $test_results_path
531 echo "fixed $test_fixed" >> $test_results_path
532 echo "broken $test_broken" >> $test_results_path
533 echo "failed $test_failure" >> $test_results_path
534 echo "" >> $test_results_path
535
536 if test "$test_fixed" != 0
537 then
538 say_color pass "fixed $test_fixed known breakage(s)"
539 fi
540 if test "$test_broken" != 0
541 then
542 say_color error "still have $test_broken known breakage(s)"
543 msg="remaining $(($test_count-$test_broken)) test(s)"
544 else
545 msg="$test_count test(s)"
546 fi
547 case "$test_failure" in
548 0)
549 say_color pass "passed all $msg"
550
551 test -d "$remove_trash" &&
552 cd "$(dirname "$remove_trash")" &&
553 rm -rf "$(basename "$remove_trash")"
554
555 exit 0 ;;
556
557 *)
558 say_color error "failed $test_failure among $msg"
559 exit 1 ;;
560
561 esac
562 }
563
564 # Test the binaries we have just built. The tests are kept in
565 # t/ subdirectory and are run in 'trash directory' subdirectory.
566 TEST_DIRECTORY=$(pwd)
567 if test -n "$valgrind"
568 then
569 make_symlink () {
570 test -h "$2" &&
571 test "$1" = "$(readlink "$2")" || {
572 # be super paranoid
573 if mkdir "$2".lock
574 then
575 rm -f "$2" &&
576 ln -s "$1" "$2" &&
577 rm -r "$2".lock
578 else
579 while test -d "$2".lock
580 do
581 say "Waiting for lock on $2."
582 sleep 1
583 done
584 fi
585 }
586 }
587
588 make_valgrind_symlink () {
589 # handle only executables
590 test -x "$1" || return
591
592 base=$(basename "$1")
593 symlink_target=$TEST_DIRECTORY/../$base
594 # do not override scripts
595 if test -x "$symlink_target" &&
596 test ! -d "$symlink_target" &&
597 test "#!" != "$(head -c 2 < "$symlink_target")"
598 then
599 symlink_target=../valgrind.sh
600 fi
601 case "$base" in
602 *.sh|*.perl)
603 symlink_target=../unprocessed-script
604 esac
605 # create the link, or replace it if it is out of date
606 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
607 }
608
609 # override all git executables in TEST_DIRECTORY/..
610 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
611 mkdir -p "$GIT_VALGRIND"/bin
612 for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
613 do
614 make_valgrind_symlink $file
615 done
616 OLDIFS=$IFS
617 IFS=:
618 for path in $PATH
619 do
620 ls "$path"/git-* 2> /dev/null |
621 while read file
622 do
623 make_valgrind_symlink "$file"
624 done
625 done
626 IFS=$OLDIFS
627 PATH=$GIT_VALGRIND/bin:$PATH
628 GIT_EXEC_PATH=$GIT_VALGRIND/bin
629 export GIT_VALGRIND
630 elif test -n "$GIT_TEST_INSTALLED" ; then
631 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
632 error "Cannot run git from $GIT_TEST_INSTALLED."
633 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
634 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
635 else # normal case, use ../bin-wrappers only unless $with_dashes:
636 git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
637 if ! test -x "$git_bin_dir/git" ; then
638 if test -z "$with_dashes" ; then
639 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
640 fi
641 with_dashes=t
642 fi
643 PATH="$git_bin_dir:$PATH"
644 GIT_EXEC_PATH=$TEST_DIRECTORY/..
645 if test -n "$with_dashes" ; then
646 PATH="$TEST_DIRECTORY/..:$PATH"
647 fi
648 fi
649 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
650 unset GIT_CONFIG
651 GIT_CONFIG_NOSYSTEM=1
652 GIT_CONFIG_NOGLOBAL=1
653 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
654
655 . ../GIT-BUILD-OPTIONS
656
657 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
658 export GITPERLLIB
659 test -d ../templates/blt || {
660 error "You haven't built things yet, have you?"
661 }
662
663 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
664 then
665 GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
666 export GITPYTHONLIB
667 test -d ../git_remote_helpers/build || {
668 error "You haven't built git_remote_helpers yet, have you?"
669 }
670 fi
671
672 if ! test -x ../test-chmtime; then
673 echo >&2 'You need to build test-chmtime:'
674 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
675 exit 1
676 fi
677
678 # Test repository
679 test="trash directory.$(basename "$0" .sh)"
680 test -n "$root" && test="$root/$test"
681 case "$test" in
682 /*) TRASH_DIRECTORY="$test" ;;
683 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
684 esac
685 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
686 rm -fr "$test" || {
687 GIT_EXIT_OK=t
688 echo >&5 "FATAL: Cannot prepare test area"
689 exit 1
690 }
691
692 test_create_repo "$test"
693 # Use -P to resolve symlinks in our working directory so that the cwd
694 # in subprocesses like git equals our $PWD (for pathname comparisons).
695 cd -P "$test" || exit 1
696
697 this_test=${0##*/}
698 this_test=${this_test%%-*}
699 for skp in $GIT_SKIP_TESTS
700 do
701 to_skip=
702 for skp in $GIT_SKIP_TESTS
703 do
704 case "$this_test" in
705 $skp)
706 to_skip=t
707 esac
708 done
709 case "$to_skip" in
710 t)
711 say_color skip >&3 "skipping test $this_test altogether"
712 say_color skip "skip all tests in $this_test"
713 test_done
714 esac
715 done
716
717 # Provide an implementation of the 'yes' utility
718 yes () {
719 if test $# = 0
720 then
721 y=y
722 else
723 y="$*"
724 fi
725
726 while echo "$y"
727 do
728 :
729 done
730 }
731
732 # Fix some commands on Windows
733 case $(uname -s) in
734 *MINGW*)
735 # Windows has its own (incompatible) sort and find
736 sort () {
737 /usr/bin/sort "$@"
738 }
739 find () {
740 /usr/bin/find "$@"
741 }
742 sum () {
743 md5sum "$@"
744 }
745 # git sees Windows-style pwd
746 pwd () {
747 builtin pwd -W
748 }
749 # no POSIX permissions
750 # backslashes in pathspec are converted to '/'
751 # exec does not inherit the PID
752 ;;
753 *)
754 test_set_prereq POSIXPERM
755 test_set_prereq BSLASHPSPEC
756 test_set_prereq EXECKEEPSPID
757 ;;
758 esac
759
760 test -z "$NO_PERL" && test_set_prereq PERL
761 test -z "$NO_PYTHON" && test_set_prereq PYTHON
762
763 # test whether the filesystem supports symbolic links
764 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
765 rm -f y